from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Globals import DTMLFile, HTMLFile
import time
import re
import urllib
import traceback, sys, os 
from OFS.SimpleItem import Item

addForm = DTMLFile('dtml/addForm',globals())

def manage_addKebasData(self, id, url, regex_pattern, start_kebas='', end_kebas='', render_method='', REQUEST=None):
	"""the add method"""
	ob = KebasData(id, url, regex_pattern, start_kebas, end_kebas, render_method)
	self._setObject(id,ob)
	if REQUEST is not None:
		return REQUEST.RESPONSE.redirect('manage_workspace') 

class KebasData(Implicit, Persistent, RoleManager, Item):
	"""my first attempt to a python product."""

	meta_type = 'Kebas Data'

	manage_options=(
              {'label' : 'Edit', 'action' : 'editKebasDataForm', 'help': ('KebasData','edit.txt')},
              {'label' : 'View', 'action' : '', 'help': ('KebasData','index.txt')},
              {'label': 'Properties' , 'action':'main'},
		) + RoleManager.manage_options + Item.manage_options

	security=ClassSecurityInfo()
	main= DTMLFile('dtml/main',globals())
	security.declareProtected('View management screens','editKebasDataForm')
	editKebasDataForm = DTMLFile('dtml/editKebasDataForm',globals())
	index_html = HTMLFile('index_html',globals())

	def __init__(self, id, url, regex_pattern, start_kebas='', end_kebas='', render_method=''):
		"""my init"""
		self.id = id
		self.url = url
		self.regex_pattern = regex_pattern
		self.start_kebas = start_kebas
		self.end_kebas = end_kebas
		self.match=[]
		self.render_method = render_method
		self.refresh_time = 3600
		self.last_refresh = time.time()
		#self.f = self._get_url()

	def _get_url(self,url, REQUEST=None):
		"""get the url"""
		#print self.url
		self.url = url
		self.start_kebas_re = re.compile(self.start_kebas, re.I|re.S|re.DOTALL)
		self.end_kebas_re = re.compile(self.end_kebas, re.I|re.S|re.DOTALL)
		try:
			self.f = urllib.urlopen(self.url).read()
		except:
			if not self.match:
                        	return self.editKebasDataForm(REQUEST,
                      			management_view='Edit',
                      				manage_tabs_message='<span style="color: red;">\
						<strong>Kebas Data not initialized.  \
                      				The url <i>%s</i> unreachable or timed out. \
                      				Check your URL</strong></span>' % self.url )
		if self.start_kebas == '' and self.end_kebas == '':
			self.f = self.f
		else:
			x = self.start_kebas_re.search(self.f)
			y = self.end_kebas_re.search(self.f)
			try:
				self.f = self.f[x.end():y.start()]
			except:
				tb = traceback.extract_tb(sys.exc_info()[2])
                		tb.reverse()
                		self._v_errors = ["failed",
                                  "%s: %s" % sys.exc_info()[:2],
                                  ] + map(str, tb)
		return self.f

		if REQUEST is not None:
			return self.editKebasDataForm(REQUEST,
                      management_view='Edit',
                      manage_tabs_message='Kebas Data attributes changed.')
	
	def index_html(self,REQUEST=None):
		"""default view"""
		head = "<html><body>"
		foot = "</body></html>"
		return head + self.view() + foot

	security.declareProtected('View management screens','get_matched')
	def get_matched(self, url=None, REQUEST=None):
		"""get the matched pattern"""
		if url is not None:
			self.url = url
			self.f = self._get_url(url=self.url)
		else:
			self.f = self._get_url(url=self.url)
		self.regex = re.compile(self.regex_pattern,re.I|re.S)
		self.match= self.regex.findall(self.f)
		self._p_changed = 1
		self.last_refresh = time.time()
		#return self.match
		if not self.match:
			return self.editKebasDataForm(REQUEST,
                      management_view='Edit',
                      manage_tabs_message='<span style="color: red;"><strong>Kebas Data not initialized.  \
		      No match found. \
		      Check your regex pattern and URL</strong></span>')
		else:
			if REQUEST is not None:
				return self.editKebasDataForm(REQUEST,
                      		management_view='Edit',
                      		manage_tabs_message='Kebas Data initialized.')
			else:
				return """ done self.index_html(REQUEST)"""
	

	#security.declareProtected('View','custom_view')
	def view(self,REQUEST=None):
		"""Custom view.  calls dtml method defined in render_method.  this is currently a hack,
		until i get the equivalent to what i'm doing here.
		What i'm doing here is - set up a file called custom_view.dtml, and has 
		<dtml-var "_[render_method]">.  any elegant way of acieving this in python?

		with TheJester's help, i have that elusive solution.
		<TheJester> calls it has a function
		<TheJester> and passes self and REQUEST through
		<TheJester> self basically gives you acquisition
		<TheJester> REQUEST gives you REQUEST
		<TheJester> d;)
		<kedai> getattr gets the the attribute if its there, and (self,REQUEST) calls it?
		<TheJester> yes
		<TheJester> you could do this...
		<TheJester> imageMethod=getattr(self, x)
		<TheJester> imageMethod(self, REQUEST)
		<TheJester> you wanna know something even sicker...
		<TheJester> imageMethod=getattr(self, x)(self, REQUEST)[5:]
		<TheJester> or even
		<TheJester> imageMethod=getattr(self, x)(self, REQUEST)['lines'][1]
		"""
		t=self._chk_time()
		if t == 1:
			self.get_matched()
		if not self.match:
                        return self.editKebasDataForm(REQUEST,
                      management_view='Edit',
                      manage_tabs_message='<span style="color: red;"><strong>Kebas Data not initialized.  \
                      No match found. \
                      Check your regex pattern and URL</strong></span>')
		if self.render_method != '':
			try:
				return getattr(self,self.render_method)(self,REQUEST)
			except:
			#	tb = traceback.extract_tb(sys.exc_info()[2])
				return self.main(REQUEST,
                      			management_view='View',
                      			manage_tabs_message='<span style="color: red;">\
					<strong>render_method defined, but no rendor_method <i>%s</i>\
                      			found</strong></span> %s' \
					 % (self.render_method,Item.raise_standardErrorMessage(self)) )
		else:
			return self.main(REQUEST)

	def _chk_time(self):
		"""Check for freshness according to user request"""
		if not hasattr(self,'last_refresh'):
                	self.last_refresh=time.time()
		if not hasattr(self,'refresh'):
			self.refresh = 3600
		self.do_refresh = 0
		delta_t = time.time() - self.last_refresh
		if delta_t > int(self.refresh):
			self.do_refresh = 1
		return self.do_refresh

	security.declareProtected('Change Kebas Data','manage_editKebasData')
	def manage_editKebasData(self, url, regex_pattern, start_kebas='', end_kebas='', render_method='',
		refresh='',  REQUEST=None):
		"""change method"""
		self.url = url
                self.regex_pattern = regex_pattern
		self.start_kebas = start_kebas
		self.end_kebas = end_kebas
                self.match=[]
		self.render_method = render_method
		if refresh == '':
			self.refresh=3600
		else:
			self.refresh=refresh
		if REQUEST is not None:
			return self.editKebasDataForm(REQUEST,
				management_view='Edit',
				manage_tabs_message = 'Attributes changed')

InitializeClass(KebasData)
